package de.dhbwloe.campusapp.fragments;

import de.dhbwloe.campusapp.CampusAppFragment;

import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentTransaction;
import android.support.v7.widget.CardView;
import android.view.InflateException;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;

import de.dhbwloe.campusapp.R;
import de.dhbwloe.campusapp.search.SearchIndices;

public class Dashboard extends CampusAppFragment {
    private static View view;
    /* implement this for search results ;) */
    public static SearchIndices[] GetSearchIndices() {
        return new SearchIndices[] {
                new SearchIndices("Dashboard", true) {{
                    setUpdateTime(1);
                    setTarget("#Dashboard");
                    setTitle(R.string.search_dashboard_title);
                    setDescription(R.string.search_dashboard_description);
                    addKeyWord(R.string.search_dashboard_keywords);
                }},
        };
    }


    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        if (view != null) {
            ViewGroup parent = (ViewGroup) view.getParent();
            if (parent != null)
                parent.removeView(view);
        }

        try {
            view = inflater.inflate(R.layout.fragment_dashboard, container, false);
        } catch (InflateException e) {
            if(view == null)
                return null;
        }
        AppContext.setTitle(AppContext.getResString(R.string.dashboard_title));

        String kursTag = AppContext.getDatabaseManager().getRuntimeCache("CourseName");
        if(kursTag == null || kursTag.isEmpty()) {
            CardView timetable = (CardView) view.findViewById(R.id.card_timetable);
            timetable.setVisibility(View.GONE);
        }

        ImageView image;
        image = (ImageView)view.findViewById(R.id.timetable_image);
        image.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                AppContext.getNavigationManager().navigatePage("Vorlesungsplan");
            }
        });

        image = (ImageView)view.findViewById(R.id.mensa_image);
        image.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                AppContext.getNavigationManager().navigatePage("Mensa");
            }
        });

        return view;
    }
}
