package de.dhbwloe.campusapp.fragments;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;

import java.util.ArrayList;

import de.dhbwloe.campusapp.R;
import de.dhbwloe.campusapp.mensaplan.*;

/**
 * Created by pk910 on 24.01.2016.
 */

public class MensaTagesplanListAdapter  extends ArrayAdapter<de.dhbwloe.campusapp.mensaplan.MensaTagesplan> {
    private Context context;
    private int layoutResourceId;
    private ArrayList<de.dhbwloe.campusapp.mensaplan.MensaTagesplan> data = new ArrayList<de.dhbwloe.campusapp.mensaplan.MensaTagesplan>();

    public MensaTagesplanListAdapter(Context context, int layoutResourceId, ArrayList<de.dhbwloe.campusapp.mensaplan.MensaTagesplan> data) {
        super(context, layoutResourceId, data);
        this.layoutResourceId = layoutResourceId;
        this.context = context;
        this.data = data;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        View row = convertView;
        RecordHolder holder = null;

        if (row == null) {
            LayoutInflater inflater = (LayoutInflater) context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
            row = inflater.inflate(layoutResourceId, parent, false);

            holder = new RecordHolder(row);
            row.setTag(holder);
        } else {
            holder = (RecordHolder) row.getTag();
        }

        final MensaTagesplanListAdapter that = this;
        final de.dhbwloe.campusapp.mensaplan.MensaTagesplan item = data.get(position);

        if(holder.txtMenueName != null)
            holder.txtMenueName.setText(item.getMenuName());
        if(holder.txtName != null)
            holder.txtName.setText(item.getName());
        if(holder.txtPrice != null)
            holder.txtPrice.setText(item.getFormatedRolePrice());

        return row;
    }

    static class RecordHolder {
        TextView txtMenueName;
        TextView txtName;
        TextView txtPrice;

        public RecordHolder(View view) {
            this.txtMenueName = (TextView) view.findViewById(R.id.txtMenueName);
            this.txtName = (TextView) view.findViewById(R.id.txtName);
            this.txtPrice = (TextView) view.findViewById(R.id.txtMenuePrice);
        }
    }
}