package de.dhbwloe.campusapp.fragments;

import java.text.SimpleDateFormat;
import java.util.Date;

import de.dhbwloe.campusapp.CampusAppContext;
import de.dhbwloe.campusapp.R;

/**
 * Created by pk910 on 28.02.2016.
 */
public class VorlesungsplanExamsListItem {
    private int groupId;
    private String courseName;
    private String groupName;
    private long eventStart, eventEnd;
    private int eventCount;

    public VorlesungsplanExamsListItem(int groupid, String coursename, String groupname, long eventstart, long eventend, int eventcount) {
        groupId = groupid;
        courseName = coursename;
        groupName = groupname;
        eventStart = eventstart;
        eventEnd = eventend;
        eventCount = eventcount;
    }

    public int getGroupId() {
        return groupId;
    }

    public String getCourseName() {
        return courseName;
    }

    public String getGroupName() {
        return groupName;
    }

    public String getEventDate() {
        if(eventStart == 0)
            return null;
        SimpleDateFormat dateFormat = new SimpleDateFormat(CampusAppContext.getInstance().getResString(R.string.timeformat_vorlesungsplan_date));
        Date date = new Date(eventStart*1000);
        return dateFormat.format(date);
    }

    public String getEventStart() {
        if(eventStart == 0)
            return null;
        SimpleDateFormat dateFormat = new SimpleDateFormat(CampusAppContext.getInstance().getResString(R.string.timeformat_vorlesungsplan_time));
        Date date = new Date(eventStart*1000);
        return dateFormat.format(date);
    }

    public String getEventEnd() {
        if(eventEnd == 0)
            return null;
        SimpleDateFormat dateFormat = new SimpleDateFormat(CampusAppContext.getInstance().getResString(R.string.timeformat_vorlesungsplan_time));
        Date date = new Date(eventEnd*1000);
        return dateFormat.format(date);
    }

    public int getEventCount() {
        return eventCount;
    }
}
