package de.dhbwloe.campusapp.fragments;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.RelativeLayout;
import android.widget.TextView;

import java.util.ArrayList;

import de.dhbwloe.campusapp.R;

/**
 * Created by pk910 on 20.02.2016.
 */
public class VorlesungsplanUpcomingDayListAdapter extends ArrayAdapter<VorlesungsplanUpcomingDayListItem> {
    private Context context;
    private int layoutResourceId;
    private ArrayList<VorlesungsplanUpcomingDayListItem> data = new ArrayList<VorlesungsplanUpcomingDayListItem>();

    public VorlesungsplanUpcomingDayListAdapter(Context context, int layoutResourceId, ArrayList<VorlesungsplanUpcomingDayListItem> data) {
        super(context, layoutResourceId, data);
        this.layoutResourceId = layoutResourceId;
        this.context = context;
        this.data = data;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        View row = convertView;
        RecordHolder holder = null;

        if (row == null) {
            LayoutInflater inflater = (LayoutInflater)context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
            row = inflater.inflate(layoutResourceId, parent, false);

            holder = new RecordHolder(row);
            row.setTag(holder);
        } else {
            holder = (RecordHolder) row.getTag();
        }

        final VorlesungsplanUpcomingDayListAdapter that = this;
        final VorlesungsplanUpcomingDayListItem item = data.get(position);

        item.addCourseEventsToContainer(holder.container);
        holder.cardDate.setText(item.getFormatedDate());

        return row;
    }

    static class RecordHolder {
        TextView cardDate;
        LinearLayout container;

        public RecordHolder(View view) {
            this.cardDate = (TextView) view.findViewById(R.id.cardDate);
            this.container = (LinearLayout) view.findViewById(R.id.cardCourses);
        }
    }
}
