package de.dhbwloe.campusapp.network;

import android.os.Bundle;
import android.util.Log;
import android.util.Xml;

import java.util.ArrayList;

/**
 * Created by pk910 on 22.01.2016.
 */
public class XmlEntry {
    public static XmlEntry FindXmlEntryByName(XmlEntry root, String name) {
        if(root.getName().equalsIgnoreCase(name))
            return root;
        for(XmlEntry entry : root.getChildren()) {
            entry = FindXmlEntryByName(entry, name);
            if(entry != null)
                return entry;
        }
        return null;
    }

    public static XmlEntry[] FindXmlEntriesByName(XmlEntry root, String name) {
        Log.i("XMLFind", "Search "+name+"  have: "+root.getName());
        if(root.getName().equalsIgnoreCase(name))
            return new XmlEntry[] { root };

        ArrayList<XmlEntry> entries = new ArrayList<XmlEntry>();
        for(XmlEntry entry : root.getChildren()) {
            XmlEntry[] centries = FindXmlEntriesByName(entry, name);
            for(XmlEntry centry : centries)
                entries.add(centry);
        }
        XmlEntry[] entriesArr = new XmlEntry[entries.size()];
        entriesArr = entries.toArray(entriesArr);
        return entriesArr;
    }


    private String name;
    private String value;
    private ArrayList<XmlEntry> children = new ArrayList<XmlEntry>();
    private Bundle attributes = new Bundle();

    public XmlEntry(String name) {
        this.name = name;
    }

    public void setValue(String value) {
        this.value = value;
    }

    public String getName() {
        return name;
    }

    public String getValue() {
        return value;
    }

    public void addChild(XmlEntry child) {
        children.add(child);
    }

    public XmlEntry[] getChildren() {
        XmlEntry childs[] = new XmlEntry[children.size()];
        childs = children.toArray(childs);
        return childs;
    }

    public void setAttribute(String name, String value) {
        attributes.putString(name, value);
    }

    public void setAttributes(Bundle bundle) {
        attributes.putAll(bundle);
    }

    public Bundle getAttributes() {
        return attributes;
    }

    public String getAttribute(String name) {
        return attributes.getString(name);
    }

}
