package de.dhbwloe.campusapp.nfcreader.MifareDESFire;

import java.io.ByteArrayInputStream;

import de.dhbwloe.campusapp.nfcreader.Hex;

/**
 * Created by pk910 on 27.01.2016.
 */
public class DesfireManufacturingData {
    public final int hwVendorID;
    public final int hwType;
    public final int hwSubType;
    public final int hwMajorVersion;
    public final int hwMinorVersion;
    public final int hwStorageSize;
    public final int hwProtocol;

    public final int swVendorID;
    public final int swType;
    public final int swSubType;
    public final int swMajorVersion;
    public final int swMinorVersion;
    public final int swStorageSize;
    public final int swProtocol;

    public final int uid;
    public final int batchNo;
    public final int weekProd;
    public final int yearProd;

    public DesfireManufacturingData (byte[] data) {
        ByteArrayInputStream stream = new ByteArrayInputStream(data);
        hwVendorID     = stream.read();
        hwType         = stream.read();
        hwSubType      = stream.read();
        hwMajorVersion = stream.read();
        hwMinorVersion = stream.read();
        hwStorageSize  = stream.read();
        hwProtocol     = stream.read();

        swVendorID     = stream.read();
        swType         = stream.read();
        swSubType      = stream.read();
        swMajorVersion = stream.read();
        swMinorVersion = stream.read();
        swStorageSize  = stream.read();
        swProtocol     = stream.read();

        // FIXME: This has fewer digits than what's contained in EXTRA_ID, why?
        byte[] buf = new byte[7];
        stream.read(buf, 0, buf.length);
        uid = Hex.byteArrayToInt(buf);

        // FIXME: This is returning a negative number. Probably is unsigned.
        buf = new byte[5];
        stream.read(buf, 0, buf.length);
        batchNo = Hex.byteArrayToInt(buf);

        // FIXME: These numbers aren't making sense.
        weekProd = stream.read();
        yearProd = stream.read();
    }

}