package de.dhbwloe.campusapp.vorlesungen;

import android.os.Bundle;
import android.provider.ContactsContract;

import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import de.dhbwloe.campusapp.database.DatabaseManager;

/**
 * Created by pk910 on 21.01.2016.
 */
public class CourseGroup {
    private static ArrayList<CourseGroup> CourseGroups = new ArrayList<CourseGroup>();
    private int iCourseGroupId;
    private String sCourseGroupName;
    private String sCourseName;
    private boolean bIsNew = false;
    private ArrayList<CourseEvent> events = new ArrayList<CourseEvent>();

    private Bundle extraData = new Bundle();

    public static CourseGroup GetCourseGroupById(DatabaseManager dbm, int id) {
        for(CourseGroup group : CourseGroups) {
            if(group.iCourseGroupId == id)
                return group;
        }
        return dbm.getCourseGroup(id);
    }

    public static CourseGroup GetCourseGroupByName(DatabaseManager dbm, String coursename, String groupname) {
        for(CourseGroup group : CourseGroups) {
            if(group.sCourseName.equalsIgnoreCase(coursename) && group.sCourseGroupName.equalsIgnoreCase(groupname))
                return group;
        }
        CourseGroup group = dbm.getCourseGroup(coursename, groupname);
        if(group == null) {
            group = dbm.addCourseGroup(coursename, groupname);
            group.bIsNew = true;
        }
        return group;
    }

    public static void ResetEventGroups() {
        for(CourseGroup group : CourseGroups) {
            group.events.clear();
        }
    }


    public CourseGroup(int id, String coursename, String groupname) {
        iCourseGroupId = id;
        sCourseGroupName = groupname;
        sCourseName = coursename;

        CourseGroups.add(this);
    }

    public void addCourseEvent(CourseEvent event) {
        this.events.add(event);
    }

    public CourseEvent[] getCourseEvents() {
        return (CourseEvent[])this.events.toArray();
    }

    public CourseEvent[] getOrderedCourseEvents() {
        CourseEvent[] events = getCourseEvents();

        Arrays.sort(events);

        return events;
    }

    public int getGroupId() {
        return iCourseGroupId;
    }

    public boolean isNewGroup(boolean reset) {
        boolean ret = bIsNew;
        if(reset)
            bIsNew = false;
        return ret;
    }

    public Bundle getExtraData() {
        return extraData;
    }

    public String getGroupName() {
        return sCourseGroupName;
    }

}
